module jp.ku6.tetris.winmain;

import core.runtime;
import core.thread;
import std.stream;
import std.math;
import jp.ku6.windows.win32api.windows;
import jp.ku6.windows.win32api.winuser;
import jp.ku6.windows.game.application;
import jp.ku6.windows.game.graphics;
import jp.ku6.windows.game.input;
import jp.ku6.windows.game.audio;
import jp.ku6.tetris.game;

//--------------------------------------------------------------
// D言語でWindowsアプリを作るときの基本処理

extern (Windows)
int WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	void exceptionHandler(Throwable e)
	{
		throw e;
	}

	int result;
	try
	{
		Runtime.initialize(&exceptionHandler);
		scope (exit) Runtime.terminate(&exceptionHandler);

		Application.startup(hInstance, 640, 480, "Test application", "Test application", null, null, null);
		scope (exit) Application.shutdown();

		Graphics.startup();
		scope (exit) Graphics.shutdown();

		Input.startup();
		scope (exit) Input.shutdown();

		Audio.startup();
		scope (exit) Audio.shutdown();

		auto tetris = new Tetris;
		scope (exit) delete tetris;

		while (Application.instance().isValid())
		{
			tetris.mainLoop();
		}
	}
	catch (Object o)
	{
		MessageBoxA(null, cast(char*)o.toString(), "Error", MB_OK | MB_ICONEXCLAMATION);
		result = 1;
	}

	return result;
}
